DATA	SEGMENT
I8255_A    EQU		210H
I8255_B    EQU		211H
I8255_C    EQU		212H
I8255_CTR  EQU		213H
I8253_0    EQU		220H
I8253_1    EQU		221H
I8253_2    EQU		222H
I8253_CTR  EQU		223H
M8259_0    EQU		200H
M8259_1    EQU		201H
S8259_0    EQU		230H
S8259_1    EQU		231H
LED_SEG    EQU		240H
LED_BIT    EQU		241H
PORTCL1    DB		81H,41H,24H,22H
PORTCL2    DB		3FH,06H,5BH,4FH,66H,6DH
CNT1       DB		5,2,3,2
CNT2       DB		0
DATA	ENDS

CODE	SEGMENT
	ASSUME	CS:CODE,DS:DATA
MAIN:      MOV		AX,DATA
		MOV		DS,AX
		CLI
		MOV		DX,M8259_0			;8259ICW
		MOV		AL,11H                ;ICW1
		OUT		DX,AL
		MOV		DX,M8259_1			
		MOV		AL,08H                ;ICW2,08H
		OUT		DX,AL
		MOV		AL,04H                ;ICW3,IR2
		OUT		DX,AL
		MOV		AL,01H                ;ICW4
		OUT		DX,AL
		MOV		AL,0FFH               ;OCW1
		OUT		DX,AL

		MOV		DX,S8259_0			;8259ICW
		MOV		AL,11H                ;ICW1
		OUT		DX,AL
		MOV		DX,S8259_1			
		MOV		AL,76H                ;ICW2,76H
		OUT		DX,AL
		MOV		AL,02H                ;ICW3
		OUT		DX,AL
		MOV		AL,01H                ;ICW4
		OUT		DX,AL
		MOV		AL,0FFH               ;OCW1
		OUT		DX,AL

		PUSH       DS                    ;8259OCW                
		MOV		AX,0
		MOV		DS,AX
		LEA		AX,CS:INT_PROC        
		MOV		SI,08H                ;BASE=08
		ADD		SI,SI
		ADD		SI,SI
		MOV		DS:[SI],AX           
		PUSH       CS                    
		POP		AX
		MOV		DS:[SI+2],AX          
		LEA		AX,CS:INTS_PROC       
		MOV		SI,76H                ;BASE=76
		ADD		SI,SI
		ADD		SI,SI		
		MOV		DS:[SI],AX            
		PUSH       CS
		POP		AX
		MOV		DS:[SI+2],AX          
		POP		DS
		MOV		DX,M8259_1
		IN		AL,DX                 ;OCW1
		AND		AL,11111010B          ;IR0\IR2
		OUT		DX,AL
		MOV		DX,S8259_1
		IN		AL,DX                 
		AND		AL,10111110B          ;IR6
		OUT		DX,AL            
		STI                              

		MOV		DX,I8255_CTR          ;8255
		MOV		AL,90H                ;?82550,PA-IN,PC-OUT
		OUT		DX,AL
		MOV		DX,I8253_CTR		;0,3,BCD
		MOV		AL,00110111B          
		OUT		DX,AL
		MOV		DX,I8253_0
		MOV		AL,0                  ;10000
		OUT		DX,AL
		OUT		DX,AL
		MOV		DX,I8253_CTR		;1,2,2
		MOV		AL,01010100B          
		OUT		DX,AL
		MOV		DX,I8253_1
		MOV		AL,100                ;100
		OUT		DX,AL
RE_ON:	MOV		BX,0                  ;0
ON:		MOV		DX,I8255_C
		XOR		CX,CX                 ;CX=0
		MOV		CL,CNT1[BX]            
		MOV		AL,PORTCL1[BX]
		OUT		DX,AL
LOP1:	 	MOV		DX,I8255_A
		IN		AL,DX
		TEST		AL,01H
		JNZ		LOP1                  ;8254	
LOP2:	 	MOV		DX,I8255_A
		IN		AL,DX
		TEST		AL,01H
		JNZ		LOP2                  ;8255A	
		CALL	     SHOW                  
		LOOP	     LOP1
		INC		BX                    ;LED
		CMP		BX,4                  ;CIRCLE?
		JE		NEXT                  
		JMP		ON
NEXT:		MOV		BX,0
		JMP		ON

SHOW	PROC
		PUSH	     BP
		MOV	     BP,CX
		PUSH	     CX
		PUSH	     BX
		PUSH	     SI
		LEA		SI,PORTCL2            
		MOV		CL,01H                
		MOV		BL,[SI+BP]
LOP:	     CALL	     DISP1                 
		CMP		CL,40H                
		JNZ		LOP
		POP		SI
		POP		BX
		POP		CX
		POP		BP
		RET
SHOW	ENDP

DISP1	PROC
           PUSH       DX
           PUSH       AX
		MOV		AL,0
		MOV		DX,LED_BIT
		OUT		DX,AL                
		CALL       DELAY
		MOV		AL,BL
		MOV		DX,LED_SEG
		OUT		DX,AL
		CALL       DELAY
		MOV		AL,CL
		MOV		DX,LED_BIT
		OUT		DX,AL                
		CALL       DELAY
		CALL       DELAY
		CALL       DELAY
		SAL		CL,1                   
		POP		AX
		POP		DX
		RET
DISP1	ENDP

DELAY	PROC
		PUSH       CX
		PUSH       DX
		MOV		DX,5
KK1:       MOV        CX,20H
KK2:       LOOP       KK2
		DEC		DX
		JNZ		KK1
		POP		DX
		POP		CX
		RET
DELAY	ENDP

INT_PROC:                                   
		PUSH       AX
		PUSH       CX
		PUSH       DX
		PUSH       BX
		MOV        DX,I8255_C
		XOR        CX,CX
		MOV        CL,5
		MOV        AL,81H
		OUT        DX,AL
LOP3:		MOV		DX,I8255_A
		IN         AL,DX
		TEST       AL,01H
		JNZ        LOP3		
LOP4:		MOV		DX,I8255_A
		IN         AL,DX
		TEST       AL,01H
		JZ        LOP4	
		LOOP       LOP3
		POP        BX
		MOV        DX,I8255_C
		MOV        AL,PORTCL1[BX]
		OUT        DX,AL
     		MOV        DX,M8259_0
		MOV        AL,20H
		OUT        DX,AL
		POP        DX
		POP        CX
		POP        AX           
		STI
		IRET
           
INTS_PROC:                                  
		PUSH       AX
		PUSH       CX
		PUSH       DX
		PUSH       BX
		MOV        DX,I8255_C
		XOR        CX,CX
		MOV        CL,5
		MOV        AL,24H
		OUT        DX,AL
LOP5:		MOV		DX,I8255_A
		IN         AL,DX
		TEST       AL,01H
		JNZ        LOP5		
LOP6:		MOV		DX,I8255_A
		IN         AL,DX
		TEST       AL,01H
		JZ         LOP6	
		LOOP       LOP5
		POP        BX
		MOV        DX,I8255_C
		MOV        AL,PORTCL1[BX+2]
		OUT        DX,AL           
		MOV        DX,M8259_0
		MOV        AL,20H
		OUT        DX,AL
		MOV        DX,S8259_0
		MOV        AL,20H
		OUT        DX,AL
		POP        DX
		POP        CX
		POP        AX          
		STI
		IRET
CODE	ENDS
		END		MAIN